'use strict'
/**
 *
 *  @class Backupのメインとなるクラス。
 *  @classdesc Backup Main
 *
 */
var Backup = function() {
    /**
    * 設定ファイルをバックアップする
    **/
    Backup.prototype.BackupSettingFile = function() {
        let fs = require('fs');
        const electron = require('electron');
        const remote = electron.remote;
        const dialog = remote.dialog;
        const browserWindow = remote.BrowserWindow;
        // ファイルに書き込む
        function writeFile(path, data) {
            fs.writeFile(path, data, function (error) {
                if (error != null) {
                    alert('error : ' + error);
                    return;
                }
            });
        }
        function saveNewFile(data) {
            let win = browserWindow.getFocusedWindow();
            dialog.showSaveDialog(
                win,
                {
                    properties: ['openFile'],
                    filters: [
                        {
                            name: 'Documents',
                            extensions: ['json']
                        }
                    ]
                },
                // セーブ用ダイアログが閉じられた後のコールバック関数
                function (fileName) {
                    if (fileName) {
                        let currentPath = fileName;
                        let json = {};
                        json.Devices = data.Devices;
                        json.Vlans = data.Vlans;
                        delete json.Devices.Mgt0;
                        json = '\ufeff' + JSON.stringify(json, undefined, 1);// 'feff'を付けるとBOM UTF8にする。
                        writeFile(currentPath, json, 'utf8');
                    }
                }
            );
        }

        $.ajax({
            type: 'GET',
            url: 'http://192.0.2.1:8080/1/setting/',
            dataType: 'json',
            timeout: 30000,
            cache: false
        }).then(
            function(data){
                $('#backup-err-msg').text('');
                saveNewFile(data);
            },
            function(err){
                $('#backup-err-msg').text('Failed to connect.');
            }
        );
    }
}

// クリックイベント
// バックアップボタンクリック
$(document).on('click', '#all-settings-backup', function(){
    backup.BackupSettingFile();
});
// 画面オープン
$(document).on('click', '#menu-backup', function() {
    $('.content-wrapper').css('display', 'none');
    $('#content-backup').css('display', 'block');
    $('.sidebar-menu li').removeClass('active');
    $('.sidebar-menu #menu-backup').addClass('active');
    if (isScenarioEmpty()) {
        $('#restore-browse').removeAttr('disabled', 'disabled');
        $('#all-settings-backup').removeAttr('disabled', 'disabled');
    } else {
        $('#restore-browse').attr('disabled', 'disabled');
        $('#all-settings-backup').attr('disabled', 'disabled');
    }
})