
//
//
//        Setting
//
//

//Reloadボタンクリック時
$(".reload_setting").click(function () {
    get_settings();
})

function get_settings() {
    // 各フィールドを空欄にする
    $('#settings-eth0-addr').val("");
    $('#settings-eth1-addr').val("");
    $('#settings-eth2-addr').val("");
    $('#settings-mgt-addr').val("");

    showBigLoader();
    // disable reload button
    $('#content-settings button').attr('disabled', 'disabled')
    // モード切替ボタンをクリックさせないようにする
    $('.cannot-click').css({'display': 'block'});

    setTimeout(function () {
        $.ajax({
            type: 'GET',
            url: 'http://192.0.2.1:8080/1/setting',
            dataType: 'json',
            timeout: 3000,
        }).then(
            function (data) {
                setting_set_form(data);
            },
            function (xhr) {
                unable_connection_msg();
            }
            )
    }, 500);
}
function setting_set_form(data) {
    if (data.Devices.Eth0.IPAddr) {
        $('#settings-eth0-addr').val(data.Devices.Eth0.IPAddr);
    }
    if (data.Vlans.Eth0 !== null) {
        if (data.Vlans.Eth0.length > 0 || $.inArray('eth0', vlan.GetModeVlan()) !== -1) {
            checkedVlan('eth0', data.Devices.Eth0.IPAddr)
        } else {
            checkedRouted('eth0', data.Devices.Eth0.IPAddr)
        }
    }
    if (data.Devices.Eth1.IPAddr) {
        $('#settings-eth1-addr').val(data.Devices.Eth1.IPAddr);
    }
    if (data.Vlans.Eth1 !== null) {
        if (data.Vlans.Eth1.length > 0 || $.inArray('eth1', vlan.GetModeVlan()) !== -1) {
            checkedVlan('eth1', data.Devices.Eth1.IPAddr)
        } else {
            checkedRouted('eth1', data.Devices.Eth0.IPAddr)
        }
    }
    if (data.Devices.Eth2.IPAddr) {
        $('#settings-eth2-addr').val(data.Devices.Eth2.IPAddr);
    }
    if (data.Vlans.Eth2 !== null) {
        if (data.Vlans.Eth2.length > 0 || $.inArray('eth2', vlan.GetModeVlan()) !== -1) {
            checkedVlan('eth2', data.Devices.Eth2.IPAddr)
        } else {
            checkedRouted('eth2', data.Devices.Eth0.IPAddr)
        }
    }
    $('.settings-msg').html('')
    if (isScenarioEmpty()) {//scenarioのcsvインポート中はApplyできない。
        removeDisable();
        $('.cannot-click').css({'display': 'none'});
    } else {
        hideBigLoader();
    }

    $('#mgt-button').attr('disabled', 'disabled')
}

function checkedVlan(device, ip) {
    $('#mode_vlan_' + device).attr('checkd', 'checkd');
    $('#mode_vlan_' + device).parent().addClass('active');
    $('#mode_routed_' + device).removeAttr('checkd', 'checkd');
    $('#mode_routed_' + device).parent().removeClass('active');
    $('#vlanmode-' + device + '-msg').addClass('disp-block');
    vlan.SetModeVlan(device)
}

function checkedRouted(device, ip) {
    $('#mode_routed_' + device).attr('checkd', 'checkd');
    $('#mode_routed_' + device).parent().addClass('active');
    $('#mode_vlan_' + device).removeAttr('checkd', 'checkd');
    $('#mode_vlan_' + device).parent().removeClass('active');
    $('#vlanmode-' + device + '-msg').removeClass('disp-block');
    vlan.RemoveModeVlan(device)
}

function removeDisable() {
    $('#content-settings button').removeAttr('disabled', 'disabled');
    hideBigLoader();
}

function unable_connection_msg() {
    hideBigLoader();
    var box_names = ["eth0", "eth1", "eth2", "mgt"]
    for (var i in box_names) {
        $('#settings-' + box_names[i] + '-msg').html('<span style="color:red">Error: Unable to connect to server.</span>')
    }
    if (isScenarioEmpty()) {//scenarioのcsvインポート中はApplyできない。
        $('#content-settings button').removeAttr('disabled', 'disabled');
    }
    $('#mgt-button').attr('disabled', 'disabled')
}

function set_interface(device, ip) {
    // IP重複チェック
    if (checkDuplicateIp(device, ip)) {
        $('#settings-' + device + '-msg').html('<span style="color:red">Error: The specified IP address is already in use.</span>')
        return false;
    }
    showBigLoader();
    $('#content-settings button').attr('disabled', 'disabled')
    $.ajax({
        type: 'PUT',
        url: 'http://192.0.2.1:8080/1/setting/device/' + device + '?ip=' + encodeURIComponent(ip),
        dataType: 'json',
        timeout: 30000,
    }).then(
        function (data) {
            $('#settings-' + device + '-msg').html('<i class="fa fa-check" style="color:#00a65a"></i>')
            removeDisable()
            $('#mgt-button').attr('disabled', 'disabled')
            if ($.inArray(device, vlan.GetModeVlan()) !== -1) {
                $('#vlanmode-' + device + '-msg').addClass('disp-block');
            }
            needle[device] = ip;
        },
        function (xhr) {
            interface_error_msg(xhr, '#settings-' + device + '-msg', 204);
        }
        )
}

/**
 * delete_interface - ETH0 ～ ETH2 のIFを削除する
 * @param  {String} device
 * @param  {String} ip
 */
function del_interface(device, ip) {
    showBigLoader();
    $('#content-settings button').attr('disabled', 'disabled')
    $.ajax({
        type: 'DELETE',
        url: 'http://192.0.2.1:8080/1/setting/device/' + device + '?ip=' + encodeURIComponent(ip),
        dataType: 'json',
        timeout: 30000,
    }).then(
        function (data) {
            $('#settings-' + device + '-msg').html('<i class="fa fa-check" style="color:#00a65a"></i>')
            removeDisable()
            $('#mgt-button').attr('disabled', 'disabled')
            $('#settings-' + device + '-addr').val('')
            needle[device] = "";
        },
        function (xhr) {
            interface_error_msg(xhr, '#settings-' + device + '-msg', 204);
        }
    )
}

// routedモードに切り替える
function switch_routed(device, isDeleted) {
    showBigLoader();
    device = (device == "") ? vlan.GetDevice() : device;
    if (isDeleted === false) {
        $('#modal-switch-routed').css({'display': 'none'});
        $('#content-settings button').attr('disabled', 'disabled')
        vlan.SetVlanValuesTriggerBySwitchRouted();
        vlan.DeleteVlan();
    }
    setTimeout(function(){ // スタックオーバーフロー予防
        // 削除が完了するまでは再帰処理
        if (vlan.GetStatus() == 'sending') {
            switch_routed(device, true);
        } else {
            vlan.RemoveModeVlan(device);
            $('#vlanmode-' + device + '-msg').removeClass('disp-block');
            removeDisable()
            $('#settings-' + device + '-msg').html('')
            $('#cannot-use-eth0, #cannot-use-eth1, #cannot-use-eth2').css({'width': '0px', 'height': '0px'});
        }
    }, 100);
}

function switch_routed_alert(device) {
    $('#modal-switch-routed').css({'display': 'block'});
    vlan.SetDevice(device);
}

function switch_vlan(device, ip) {
    $('#vlanmode-' + device + '-msg').addClass('disp-block');
    vlan.SetModeVlan(device)
}

//statusに応じて任意セレクタにエラー表示
function interface_error_msg(xhr, selector, status_num) {
    if (xhr.status === status_num) {
        $(selector).html('<i class="fa fa-check" style="color:#00a65a"></i>')
    } else if (xhr.responseJSON) {
        $(selector).html('<span style="color:red">Error: ' + xhr.responseJSON.Message + '</span>')
    } else {
        $(selector).html('<span style="color:red">Error: Unable to connect to server.</span>')
    }
    removeDisable()
    $('#mgt-button').attr('disabled', 'disabled')
}

function checkDuplicateIp(device, ip) {

    if (ip == "") {return false;}
    var count = 0;
    for (var key in needle) {
        if (device === key) {continue;}

        switch (true) {
            case /^eth\d$/.test(key):
                if (ip.split('/')[0] === needle[key]) {
                    count++;
                }
                break;
            case /^vlan$/.test(key):
                for (k in needle.vlan) {
                    if (needle.vlan[k] === null) {continue;}
                    for (var i = 0; i < needle.vlan[k].length; i++) {
                        if (ip.split('/')[0] === needle.vlan[k][i].Ip.split('/')[0]) {
                            count++;
                        }
                    }
                }
                break;
        }
    }
    return (count > 0) ? true : false;
}

function cancelSwitchRouted() {
    $('#modal-switch-routed').css('display', 'none');
    $('#mode_vlan_' + vlan.GetDevice()).parent().addClass('active');
    $('#mode_routed_' + vlan.GetDevice()).removeAttr('checkd', 'checkd');
    $('#mode_routed_' + vlan.GetDevice()).parent().removeClass('active');
}

// Settingクリック時
$(".sidebar-settings").click(function() {
    $('.content-wrapper').css('display', 'none');
    $('#content-settings').css('display', 'block');
    $('.sidebar-menu li').removeClass('active')
    $('.sidebar-menu #menu-settings').addClass('active')
    get_settings();
});