Settings = function() {
    var test = new Test();
    var DELEY_TIME = 2000;
    var INVALID_DELEY_TIME = 1000;
    var CONFIRM_TIME = 2000;
    var test_interface = null;

    Settings.prototype.ExitError = function(error_name) {
        var message_areas = null;
        var errormsg = null;
        switch (this.test_interface) {
            case "eth0":
                message_areas = "#settings-eth0-msg";
                break;
            case "eth1":
                message_areas = "#settings-eth1-msg"
                break;
            case "eth2":
                message_areas = "#settings-eth2-msg"
                break;
            case "gateway":
                message_areas = "#settings-gateway-msg"
                break;
            case "dns":
                message_areas = "#settings-dns-msg"
                break;
        }
        var errormsg = test.getButtonBesideMessage(message_areas);
        console.log("errormsg: ", errormsg)
        var result = errormsg.indexOf(error_name);
        if (result === -1) {//エラー文が存在しない
            return false;
        } else {
            return true;
        }
    }

    Settings.prototype.NormalCheck = function(selector, test_number) {
        console.log("Check : " + selector);
        ++count;
        var result = test.isCheck(selector);
        if (result) {
            TestResult("OK", test_number);
        } else { TestResult("NG", test_number); }
    }

    Settings.prototype.AbnormalCheck = function(error_name, test_number) {
        ++count;
        console.log("Check: " + error_name);
        var result = this.ExitError(error_name);
        if (result) {
            TestResult("OK", test_number);
        } else { TestResult("NG", test_number); }
    }

    Settings.prototype.Normal = function(n) {
        var that = this;
        switch (n) {
            case 0:
                $("#settings-eth0-addr").val("192.168.81.251/24");
                $("#settings-eth0-button").click();
                setTimeout(function() { that.NormalCheck("#settings-eth0-msg", "6") }, DELEY_TIME);
                break;
            case 1:
                $("#settings-eth1-addr").val("200.200.200.2/24");
                $("#settings-eth1-button").click();
                setTimeout(function() { that.NormalCheck("#settings-eth1-msg", "7") }, DELEY_TIME);
                break;
            case 2:
                $("#settings-eth2-addr").val("172.16.0.200/24");
                $("#settings-eth2-button").click();
                setTimeout(function() { that.NormalCheck("#settings-eth2-msg", "8") }, DELEY_TIME);
                break;
            case 3:
                $("#settings-dns").val("8.8.8.8");
                $("#settings-dns-button").click();
                setTimeout(function() { that.NormalCheck("#settings-dns-msg", "11") }, DELEY_TIME);
                break;
            case 4:
                $("#settings-dns").val("8.8.8.7");
                $("#settings-dns-button").click();
                setTimeout(function() { that.NormalCheck("#settings-dns-msg", "12") }, DELEY_TIME);
                break;
            case 5:
                input_ips = ["200.16.0.5/24", "200.168.1.111/25", "200.168.1.111/25", "200.168.84.1", "200.168.84.1"];
                $("#settings-eth0-addr").val(input_ips[0]);
                $("#settings-eth1-addr").val(input_ips[0]);
                $("#settings-eth2-addr").val(input_ips[0]);
                $("#settings-gateway").val(input_ips[0]);
                $("#settings-dns").val(input_ips[0]);
                setTimeout(function() { $("#setting-reload").click(); }, CONFIRM_TIME);//目視確認用時間
                break;
            default:
                console.info("Test End");
                count = 0;
                break;
        }
    }

    Settings.prototype.InvalidIPs = function(button_selector, n) {
        var that = this;
        var specified_ip = "192.168.0.1"
        var adjust_num = 0;
        var set_ip = null;
        var addr_selector = null;
        if (this.test_interface === "eth0") {
            adjust_num = 16;
            addr_selector = "#settings-eth0-addr";
            set_ip = test.invalid_prefix_ips[n % 10];
        } else if (this.test_interface === "eth1") {
            adjust_num = 28;
            addr_selector = "#settings-eth1-addr";
            set_ip = test.invalid_prefix_ips[n % 10];
        } else if (this.test_interface === "eth2") {
            adjust_num = 40;
            addr_selector = "#settings-eth2-addr";
            set_ip = test.invalid_prefix_ips[n % 10];
        } else if (this.test_interface === "gateway") {
            adjust_num = 52;
            addr_selector = "#settings-gateway";
            set_ip = test.invalid_no_prefix_ips[n % 10];
            if (n > 8) n += 2; //invalid_no_prefix_ipsは8個なので2加算して8の後に11を行う。
        } else if (this.test_interface === "dns") {
            adjust_num = 61;
            addr_selector = "#settings-dns";
            set_ip = test.invalid_no_prefix_ips[n % 10];
            if (n > 8) n += 2; //invalid_no_prefix_ipsは8個なので2加算して8の後に11を行う。
        }
        switch (n) {
            case 0:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 1:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 2:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 3:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 4:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 5:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 6:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 7:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 8:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 9:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 10:
                $(addr_selector).val(set_ip);
                $(button_selector).click();
                break;
            case 11://通信が切れてから実行する。
                $(button_selector).click();
                break;
            case 12://dnsの既に設定済みのipをチェックするために指定のipをセットする。
                if (this.test_interface === "dns") {
                    $(addr_selector).val(specified_ip);
                    $(button_selector).click();
                    ++count;//checkがなく加算されないため、ここで加算する。
                }
                break;
            case 13://dnsの既に設定済みのipをチェック
                if (this.test_interface === "dns") {
                    $(addr_selector).val(specified_ip);
                    $(button_selector).click();
                }
                break;
        }if (n < 11) {
            if (this.test_interface == "gateway") {
                setTimeout(function() { that.AbnormalCheck("Invalid next-hop address is specified", n + adjust_num) }, INVALID_DELEY_TIME);
            } else {
                setTimeout(function() { that.AbnormalCheck("Invalid IP address is specified", n + adjust_num) }, INVALID_DELEY_TIME);
            }
        } else if (n === 11) {
            setTimeout(function() { that.AbnormalCheck("Unable to connect to server", n + adjust_num) }, INVALID_DELEY_TIME);
        } else if (n === 13) {
            setTimeout(function() { that.AbnormalCheck("The specified DNS server is currently set", n + adjust_num) }, INVALID_DELEY_TIME);
        } else if (n > 13) {
            console.info("Test End");
            count = 0;
        }
    }
}
$("#setting-normal").click(function() {
    settings.Normal(count);
})
$("#setting-invalid-eth0").click(function() {
    settings.test_interface = "eth0";
    settings.InvalidIPs("#settings-eth0-button", count);
})
$("#setting-invalid-eth1").click(function() {
    settings.test_interface = "eth1";
    settings.InvalidIPs("#settings-eth1-button", count);
})
$("#setting-invalid-eth2").click(function() {
    settings.test_interface = "eth2";
    settings.InvalidIPs("#settings-eth2-button", count);
})
$("#setting-invalid-gateway").click(function() {
    settings.test_interface = "gateway";
    settings.InvalidIPs("#settings-gateway-button", count);
})
$("#setting-invalid-dns").click(function() {
    settings.test_interface = "dns";
    settings.InvalidIPs("#settings-dns-button", count);
})
$("#setting-duplicate-ips").click(function() {
    settings.DuplicateIPs(count);
})